<?php
/*
Plugin Name: WPKJ Block Search Words
Plugin URI: https://www.wpdaxue.com/wordpress-block-search-words.html
Description: Block malicious search terms.
Version: 1.0.0
Author: WPKEJI.COM
Author URI: https://www.wpkeji.com
License: GPL-3.0
Text Domain: wpkj-block-search-words
*/

add_action('admin_init', 'wpkj_block_search_words');
function wpkj_block_search_words() {
    add_settings_field('wpkj_block_search_words', '搜索关键词屏蔽', 'wpkj_block_search_words_callback', 'reading');
    register_setting('reading','wpkj_block_search_words');
}

function wpkj_block_search_words_callback() {
    echo '<textarea name="wpkj_block_search_words" rows="10" cols="50" id="wpkj_block_search_words" class="large-text code">' .
    get_option('wpkj_block_search_words') . '</textarea>';
    echo '<p class="description">每行一个关键词，建议每个关键词简短一些</p>';
}

add_action('template_redirect', 'wpkj_block_search_words_redirect');
function wpkj_block_search_words_redirect(){
    if (is_search()) {
    global $wp_query;
    $wpkj_block_search_words = get_option('wpkj_block_search_words');
    if($wpkj_block_search_words){
        $wpkj_block_search_words = str_replace("\r\n", "|", $wpkj_block_search_words);
        $block_words = explode('|', $wpkj_block_search_words);
        $search_word = $wp_query->query_vars;
            foreach($block_words as $word ){
                if( stristr($search_word['s'], $word) !== false ){
                    wp_die('请不要搜索非法关键字');
                }
            }
        }
    }
}


add_filter( 'mwtsa_exclude_term', 'wpkj_mwtsa_exclude_term', 10, 2 );
function wpkj_mwtsa_exclude_term( $status, $search_term ) {
    
    if (  class_exists( 'MWTSA_Process_Query' ) ) {
        $wpkj_block_search_words = get_option('wpkj_block_search_words');
        if($wpkj_block_search_words){
            $wpkj_block_search_words = str_replace("\r\n", "|", $wpkj_block_search_words);
            $block_words = explode('|', $wpkj_block_search_words);
    
            foreach($block_words as $word ){
                if( stristr( $search_term, $word) !== false ){
                    return true;
                }
            }
        }
    }
}
